<?php

class Updates extends DashboardPlugin
{
  static $position = "top";
  static $sort = 0;

  /**
	 * @var $ss_link = The link to download the latest Silverstripe
   */
	static $ss_link = 'http://www.silverstripe.org/stable-download/';
  
	/**
	 * The GetUpdates method screenscrapes the html interface of the silverstripe SVN repo and retrieves the latest
	 * version number, then compares that to the current version number. If the SVN version is greater, it flags an
	 * update message. 
	 * 
	 * @return A message with info about updating.
	 */
	
	public function GetUpdates() {
		// Initial variables about SVN location and Current version
		$url = 'http://svn.silverstripe.com/open/modules/sapphire/tags/';
		$verList = array();
		$curVersion = LeftAndMain::CMSVersion();
		$curVersion = floor(str_replace(array('.','/'),'',$curVersion));
		
		// Get HTML from Silverstripe SVN browser, then pull out all A tags
		$doc = new DOMDocument();
		$doc->loadHTMLFile($url);
		$items = $doc->getElementsByTagName('a');
		
		// Loop trough all A tags and attempt to convert their value to Int. If success
		// add the value to $verList array. 
		foreach($items as $item) {
			$result = $item->nodeValue;
			$strip = str_replace(array('.','/'), '', $result);
			
			if(floor($strip))
				array_push($verList,$result);
		}
		
		// Retrieve the last item in the $verList array and converty to int
		$latest = floor(str_replace(array('.','/'), '', $verList[count($verList) - 1]));
		
		// If latest version if later than current version, return an update message.
		if($latest > $curVersion)
			return 'Silverstripe ' . str_replace('/','',$verList[count($verList) - 1]) . ' is available. The latest version can be found <a href="' . self::$ss_link . '" title="Silverstripe download page">here</a>, or update your SVN.';
		
	}

}